--trkin 2015: malcolm newman deluxe edition
--written by tertu marybig (fsx)
--if you find anything of use in this godforsaken pile of shit feel free
--to use it for whatever you want
math.randomseed(os.time())
local frac = math.random
startTime = love.timer.getTime()
endTime = startTime + 60
counter = 0
subCounter = 0
mode = "warning"
drawnFrameThisMode = false
modeLock = false
truckPos = 10
grid = {}
newmanX = -100
newmanY = -100
hits = 0
updates = 0

twuk = love.graphics.newImage "twuk.png"
newman = love.graphics.newImage "newman.jpg"

function calc_vertices(row, column)
	local xr = (column-1)*30
	local xl = column*30
	local yt = 800-row*40
	local yb = 840-row*40
	return xr, yt, xr, yb, xl, yb, xl, yt
end 

function set_mode(newMode)
	if modeLock then return false end
	modeLock = true
	drawnFrameThisMode = false
	mode = newMode
	modeLock = false
end

--print(_VERSION)

function getColor2(which)
	local ctable = {0,0,0,255}
	ctable[((which-1)%3)+1] = 255
	return unpack(ctable)
end

function getColorStatic()
	return 201, 160, 220, 255
end

function white()
	return 255,255,255,255
end

getColor = getColor2

function love.draw()
	--if we're in the middle of changing modes, don't draw
	--i don't think this can happen
	if modeLock then return end
	modeLock = true
	drawnFrameThisMode = true
	modeLock = false
	if mode == "warning" then
		return draw_warning()
	elseif mode == "game" then
		return draw_game()
	elseif mode == "grade" then
		return draw_grade()
	else
		error("draw: unrecognized mode \""..mode.."\"")
	end
end

function love.keypressed(...)
	if not drawnFrameThisMode then return end
	if mode == "warning" then
		return input_warning(...)
	elseif mode == "game" then
		return input_game(...)
	elseif mode == "grade" then
		--nothing
	else
		error("keypressed: unrecognized mode \""..mode.."\"")
	end
end

function love.update()
	if mode == "game" and drawnFrameThisMode then
		updates = updates + 1
		if grid[1] == truckPos then hits = hits + 1 end		
		grid[21] = math.random(1,40)
		for i=1,20 do
			grid[i] = grid[i+1]
		end		
	end
end

function draw_grid()
	love.graphics.setColor(white())
	for i=1, 20 do
		if grid[i] then
			love.graphics.polygon( 'fill', calc_vertices(i, grid[i]) )
		end
	end
end

function do_newman()
	love.graphics.setColor(255,255,255,96)
	love.graphics.draw(newman,newmanX,newmanY,0,8)
	newmanX = newmanX + math.random(-1,1)
	newmanY = newmanY + math.random(-1,1)
end

do
	local text = 
[[This game optionally includes flashing colors.
Press Enter to start the game with them
or Shift to start without them.]]
	function draw_warning()
		do_newman()
		love.graphics.setColor(white())
		love.graphics.print(text,0,250,0,2)
	end
	function input_warning(key)
		if key == "return" then
			return set_mode "game"
		elseif key == "lshift" or key == "rshift" then
			getColor = getColorStatic
			return set_mode "game"
		end
	end
end

function input_game(key)
	local truck = truckPos
	if key == "left" then
		truck = truck - 1
	end
	if key == "right" then
		truck = truck + 1
	end
	truckPos = ((truck-1)%20)+1
end

function dude()
	love.graphics.setColor(white())
	love.graphics.draw(twuk,(truckPos-1)*40,540,0,2)
end

function draw_game()
	do_newman()
	draw_grid()
	dude()
	timer() --timer also handles color animation if enabled
end

function draw_grade()
	do_newman()
	love.graphics.setColor(getColorStatic())
	love.graphics.print("Score: "..hits.."/"..updates,400,300,0,4)
end

function timer()
	subCounter = subCounter + 1
	if subCounter % 5 == 0 then
		counter = counter + 1
	end
	love.graphics.setColor(getColor(counter))
	local curTime = love.timer.getTime()
	if curTime>=endTime then
		mode = "grade"
	end
	love.graphics.print(string.format("%02.1f",endTime-curTime),0,0,0,8)
end
